;; reads and plots FGM magnitude and reference scalar field (ground measurements)

@userlib.pro
;-------------------------------------------------------------------------
PRO a1
;-------------------------------------------------------------------------
common data
fnam='ground_bvalues.txt'
read_input,t,b,nli,fnam

bfgm=magn(b(0:2,*))          ;magnitude of FGMmag-field
bext=transpose(b(3,*))   ;magnitude given by reference instr.
@calib_param_a.txt          ;magnitude of calibrated FGMmag-field
mcalm=calm(*,1:3)
bcalib=magn(bcal(calm))

;PLOT
window,1 & !p.multi=[0,1,3] & chars=2
yr=[min([bfgm,bext]),max([bfgm,bext])]

;panel 1 -  magnitudes over plot
plot,bfgm,/xsty,ytitle='B [nT]',title=fnam,yrange=yr,charsize=chars
oplot,bext,line=2

;panel 2 - differences of magnitudes: uncalibrated - external reference
plot,bfgm-bext,/xsty,ytitle='delta_B [nT]',charsize=chars
oplot,bext-bext,line=3

;panel 3 - differences of magnitudes: calibrated - external reference
plot,bcalib-bext,/xsty,ytitle='delta_B [nT]',charsize=chars
oplot,bext-bext,line=3

!p.multi=0
end
