;; reads and plots FGM magnitude and reference scalar field (ground measurements)

@userlib.pro
;-------------------------------------------------------------------------
PRO a2
;-------------------------------------------------------------------------
common data
nr_parameters=12   ;,4,12'

fnam='ground_bvalues.txt'
read_input,t,b,nli,fnam

bfgm=magn(b(0:2,*))      ;magnitude of FGMmag-field
bext=transpose(b(3,*))   ;magnitude given by reference instr.
@calib_param_a.txt          ;magnitude of calibrated FGMmag-field
mcalm=calm(*,1:3)

print,'performing fit...'
init_powell,nr_parameters,calm,xi,Ftol
POWELL,calm,xi,Ftol,fmin,'chisqu',iter=it  ;vari for offs
print,it,fmin & print,calm
bfit=bcal(calm) & bmagf=magn(bfit)

;;; PLOT magnitudes
window,0 & !p.multi=[0,1,2]
yr=[min([bfgm,bmagf]),max([bfgm,bmagf])]
plot,bfgm,/xsty,charsize=1.2,yrange=yr,ytitle='B/nT'
oplot,bmagf
;;; PLOT magnitude-differences to external field
if n_elements(bext) gt 0 then begin
yr=[min([bfgm-bext,bmagf-bext]),max([bfgm-bext,bmagf-bext])]
plot,bfgm-bext,/xsty,charsize=1.2,yrange=yr,ytitle='delta_B/nT'
oplot,bmagf-bext & oplot,bmagf-bmagf,line=2
endif

!p.multi=0
end
