;; ground measurement : variance of magnitude versus offsets

@userlib.pro
;-------------------------------------------------------------------------
pro a3
;-------------------------------------------------------------------------
common data
fnam='ground_bvalues.txt'

read_input,t,b,nli,fnam
bext=transpose(b[3,*])
@calib_param_a.txt
mcalok=calm
offs0=[0.,0.,0.]*1.d0
mcal0=[[1.,0.,0.],[0.,1.,0.],[0.,0.,1.]]*1.d0
mcal=mcal0 & bcal0=magn(bcal(offs0))
res=variance(bcal0,/double) & print,mean(bcal0),res
offsok=mcalok[0:2,0] & mcalm=mcalok[0:2,1:3] & bcalf=magn(bcal(offsok))
res=variance(bcalf,/double) & print,mean(bcalf),res
titl='Offsets(x,y,z) ='+string(offsok(0),offsok(1),offsok(2),format="(3(f7.2,','))")
window,2
plot,bcal0,line=2,/xsty,ytitle='deltaB',title=titl,$
       yrange=[min([bcal0,bcalf]),max([bcal0,bcalf])]
oplot,bcalf & oplot,bcalf-bcalf & oplot,bext

; magnitude dependence on offset
offs=offs0  & step=0.2 & nsteps=51l
fnam='a3_var'+string(nsteps-1,format="(i03)")
startv=-5. & chi2=fltarr(nsteps,nsteps,nsteps)
if file_search(fnam+'.offs') then begin
    openr,1,fnam+'.offs' & readf,1,chi2 & close,1
    goto,plotlb
    endif
print,'WAIT PLEASE . . . computing variance in',nsteps-1,'^3 =',(nsteps-1)^3,' points'
flush,0 & wait,1
for ix=0,nsteps-1 do begin
     offs(0)=startv+ix*step
     for iy=0,nsteps-1 do begin
           offs(1)=startv+iy*step
           for iz=0,nsteps-1 do begin
                 offs(2)=startv+iz*step
                 ;chi2(ix,iy,iz)=variance(magn(bcal(offs)),/double)
                 chi2(ix,iy,iz)=chisqu(offs)
           endfor
      endfor
endfor
openw,1,fnam+'.offs' & printf,1,chi2 & close,1
plotlb:
minim=min(chi2,mi)
iz=mi/nsteps^2 & nz=startv+iz*step
iy=(mi mod nsteps^2)/nsteps & ny=startv+iy*step
ix=mi mod nsteps  & nx=startv+ix*step
titl='Offsets(x,y,z) ='+string(nx,ny,nz,format="(3(f6.1,','))")
bcaln=magn(bcal([nx,ny,nz]))
res=variance(bcaln,/double) & print,mean(bcaln),res
window,3
plot,bcal0,linestyle=2,/xsty,ytitle='deltaB',title=titl,$
       yrange=[min([bcal0,bcalf]),max([bcal0,bcalf])]
oplot,bcalf,linestyle=2 & oplot,bcalf-bcalf & oplot,bcaln
write_png,fnam+'deltB.png',tvrd()
print,'Offsets: ',nx,ny,nz,'  MIN Variance: ',chi2(ix,iy,iz)
window,0
nxx=findgen(nsteps)*step+startv & nyy=nxx & nzz=nxx
zz=alog10(chi2(*,*,iz))
show3,zz,nxx,nyy,e_contour={nlevels:25,charsize:2,c_charsize:0,zvalue:0},e_surface={charsize:2,xtitle:'Zx',ytitle:'Zy',title:titl}
write_png,fnam+'_xy.png',tvrd()
m=alog10(chi2(ix,*,*)) & zz(0:nsteps-1,0:nsteps-1)=m(0,0:nsteps-1,0:nsteps-1)
show3,zz,nyy,nzz,e_contour={nlevels:25,charsize:2,c_charsize:0,zvalue:0},e_surface={charsize:2,xtitle:'Zy',ytitle:'Zz',title:titl}
write_png,fnam+'_yz.png',tvrd()
m=alog10(chi2(*,iy,*)) & zz(0:nsteps-1,0:nsteps-1)=m(0:nsteps-1,0,0:nsteps-1)
show3,zz,nxx,nzz,e_contour={nlevels:25,charsize:2,c_charsize:0,zvalue:0},e_surface={charsize:2,xtitle:'Zx',ytitle:'Zz',title:titl}
write_png,fnam+'_xz.png',tvrd()
print,'PROGRAM finished'
end
;shade_surf,zz,nxx,nyy,charsize=2.,/save
;contour,zz,nxx,nyy,nlevels=25,charsize=2.,/noerase,/t3d,zvalue=0,c_charsize=0
