
;-------------------------------------------------------------------------
FUNCTION magn,vector
;
;      computes the magnitude of a vector or array of vectors
;      INPUT:   vector=dblarr(3)
;      OUTPUT:  magnitude
;
;-------------------------------------------------------------------------
ns=size(vector) & ndim=ns[0] & n1=long(ns[1]) & n2=long(ns[2])
v2=vector*vector
if n1 eq 3 then begin
if ndim eq 1 then begin m=sqrt(total(v2)) & goto,endlbl & end else begin $
m=dblarr(n2) & for i=0l,n2-1l do m[i]=sqrt(total(v2[*,i]))& end
endif
if ndim eq 2 and n2 eq 3 then begin m=dblarr(n1) & $
for i=0l,n1-1l do m[i]=sqrt(total(v2[i,*])) & end
endlbl:
return,m
end

;-------------------------------------------------------------------------
 function bcal,calm
;-------------------------------------------------------------------------
 common data,b,nli,mcalm
 mag=b(0:2,*)
 nr=n_elements(calm)
 if nr le 4 then  $                             ;only offsets
        for j=0,nli-1 do  mag(0:2,j)=mcalm # b(0:2,j) - calm(0:2) $
else begin                                     ;whole calibr.matrix
    mcalm=dblarr(3,3)
    for i=0,2 do mcalm(i,0:2)=calm(3*(i+1):3*(i+1)+2)
    for j=0,nli-1 do  mag(0:2,j)=mcalm # b(0:2,j) - calm(0:2)
endelse
return,mag
end

;-------------------------------------------------------------------------
function chisqu,calm
;-------------------------------------------------------------------------
common data
nr=n_elements(calm)
mag=magn(bcal(calm))
if nr eq 4 then $
mag=mag-calm(nr-1) else mag=mag-b(3,*)
return,total(mag^2)/(nli-1)
end

;-------------------------------------------------------------------------
pro read_input,t,b,nli,fnam
;-------------------------------------------------------------------------
;reads example text-input files for CS-eg
if n_elements(fnam) eq 0 then $
    filenam = DIALOG_PICKFILE(FILTER='*.txt',path='input') else filenam=fnam
nli=file_lines(filenam) & fstr=strarr(nli)
openr,1,filenam & readf,1,fstr & close,1
fstr=fstr(where(strlen(fstr) gt 2,nli))
b=dblarr(5,nli) & reads,fstr,b & t=0
if strpos(filenam,'ground') lt 0 then  begin
       t=transpose(b(0,*))  & b=b(1:4,*) & endif
fnam=filenam
end

;-------------------------------------------------------------------------
PRO init_powell,nr_parameters,calm,xi,Ftol
;-------------------------------------------------------------------------
calm = [0.0,0.0,0.0]*1.d0   ;Provide an initial guess for the calibr. parameters.
case nr_parameters of
    3: calm=calm
    4: calm=[calm,0.d0]
  12: calm=[calm,1.,0.,0.,0.,1.,0.,0.,0.,1.]*1.d0
else:print,'choose nr_of _fit_parameters=3,4,12'
endcase
Ftol=1.e-4 & xi=identity(nr_parameters)
END

