;; s/c data: plots magnitude of uncalibrated data and FFT
@userlib.pro
;-------------------------------------------------------------------------
pro b1
;-------------------------------------------------------------------------
inpf='b_uncal.txt'
fnam='ex_b1'

;; READ uncal
read_input,t,b,nli,inpf
b0=b(0:2,*)
bmag0=magn(b0) & nr=n_elements(bmag0)

;; PLOT magnitude
window,2 & !p.multi=[0,1,3]  &chars=2
plot,t,bmag0,/xsty,/ysty,ytitle='B/nT',xtitle='hours',charsize=chars

;; Compute sample_rate & define frequencies
dt=t-shift(t,1)
sampling=mean(dt(where(dt gt 0)))*3600.d0
frqreso=1.d0/nr/sampling
freq=findgen(nr/2)*frqreso ;& print,sampling,frqreso

;; PLOT FFT of magnitude and one component
fft0=fft(bmag0-mean(bmag0),-1,/double)
fftc=fft(b(1,*)-mean(b(1,*)),-1,/double)
spin=max(abs(fftc(0:nr/2-1))^2,ma)
spinfrq=freq(ma)
yr=[1.0e-10,1.0e5]
plot,freq,abs(fftc(0:nr/2-1))^2,/ylog,xrange=[0,2.],/xsty,yrange=yr,$
       xtitle='freq[Hz]',ytitle='power sp of By [nT^2/Hz]',charsize=chars
plots,[spinfrq,spinfrq],[yr(0),1.e-5],line=2
plot,freq,abs(fft0(0:nr/2-1))^2,/ylog,xrange=[0,2.],/xsty,yrange=yr,$
       xtitle='freq[Hz]',ytitle='power sp of B_uncal [nT^2/Hz]',charsize=chars
plots,[spinfrq,spinfrq],[yr(0),1.e-5],line=2
plots,[2*spinfrq,2*spinfrq],[yr(0),1.e-5],line=2

;; Save plot
write_png,fnam+'_fft.png',tvrd()
end
